;
; Name: 	Protected mode 32-bit user code module
; Version:	0.90
; Date: 	Dec-16-1999
; Author:	Vladimir Arnost  <arnost@dcse.fee.vutbr.cz>
; Compiler:	TASM 3.2
;
; History:
;   0.90  Dec-16-1999	32-bit code module created
;
; WARNING: THIS CODE IS UNDER CONSTRUCTION. USE AT YOUR OWN RISK!
;

.386p
LOCALS
JUMPS
.CREF
PAGE 60,132

INCLUDE 	KERNEL.INC

SELECTOR	S_USER_CODE,d_user_code,SEL_GDT,SEL_RPL3
SELECTOR	S_USER_DATA,d_user_data,SEL_GDT,SEL_RPL3

OPENSEG		USER_INIT_CODE 'CODE'
		ASSUME	CS:USER_INIT_CODE, DS:NOTHING

		PUBLIC	RM_Init, RM_Cleanup

;*** Real-mode initialization function. It should set PM_Entry to point
;*** to protected-mode user code entry point (Selector:Offset)
; In:		none
; Out:		none
; Changes:	AX, ES
RM_Init		PROC	FAR
		mov	ax,SEG PM_Entry
		mov	es,ax
		ASSUME	ES:NOTHING
		mov	es:PM_Entry.OFFS,low offset PM_Main
		mov	es:PM_Entry.SEGM,S_USER_CODE
		ret
RM_Init		ENDP

;*** Real-mode shutdown function. Responsible for cleaning up anything that
;*** needs to
; In:		none
; Out:		none
; Changes:	none
RM_Cleanup	PROC	FAR
		ret
RM_Cleanup	ENDP

CLOSESEG	USER_INIT_CODE


; declare 32-bit code segment
OPENSEG		USER_CODE 'CODE' USE32
		ASSUME	CS:USER_CODE, DS:USER_DATA

;*** Protected mode user code entry point (CPL=3)
; In:		none
; Out:		none
; Changes:	anything
PM_Main 	PROC	FAR
		mov	eax,S_USER_DATA
		mov	ds,ax
; put something on the stack to test things
		push	12345678h
		mov	ebp,87654321h
; Print a message
		mov	ah,07h
		CALL_API API_CLRSCR	; clear screen
		mov	si,offset msg_insidePM
		mov	ah,0Ah
		CALL_API API_PRINTSTR	; print string
; do something
		mov	eax,S_VGA_TEXT
		mov	es,ax
		xor	eax,eax
		mov	ebx,40000
@@1:		cmp	ebx,20000
		jne	@@1a
; generate some exceptions
;;		db	0fh, 0ffh	; invalid opcode
		int	3		; breakpoint
;;		int	4		; overflow
;;		mov	ax,0123h
;;		mov	ss,ax		; GPF
;
@@1a:		mov	ecx,80
		mov	edi,(20*80)*2
@@2:		add	WORD PTR es:[edi],ax
		inc	eax
		add	edi,2
		loop	@@2
		dec	ebx
		jnz	@@1
;
		mov	si,offset msg_pressanykey
		mov	ah,07h
		CALL_API API_PRINTSTR	; print string
@@3:		CALL_API API_GETKEY
		jc	@@3
		push	ax
		mov	si,offset msg_pressedkey
		mov	ah,07h
		CALL_API API_PRINTSTR	; print string
		pop	dx
                mov	cx,4
		CALL_API API_PRINTHEX	; print hexadecimal
		mov	si,offset msg_crlf
		mov	ah,07h
		CALL_API API_PRINTSTR	; print string

; Return back to real-mode
                CALL_API API_EXIT	; exit to DOS

PM_Main 	ENDP

user_code_end	LABEL	DWORD
CLOSESEG	USER_CODE

;**********************************************************************

OPENSEG		USER_DATA

msg_insidePM	db	'Inside 32-bit protected mode...', CRLF, 0
msg_pressanykey	db	'Press any key...', CRLF, 0
msg_pressedkey	db	'Pressed key code: ', 0
msg_crlf	db	CRLF, 0

user_data_end	LABEL  WORD
CLOSESEG	USER_DATA

;**********************************************************************

OPENSEG		MAIN_GDT
d_user_code	descr	<low offset user_code_end-1,seg USER_CODE,0,TYPE_CODE or DPL3,EXT_USE32,?>
d_user_data	descr	<    offset user_data_end-1,seg USER_DATA,0,TYPE_DATA or DPL3,EXT_USE16,?>
CLOSESEG	MAIN_GDT

;**********************************************************************

OPENSEG		MAIN_LDT
;		descr	<>
CLOSESEG	MAIN_LDT

;**********************************************************************

		END

; End of file
